Index: crt/string/scanf.c
===================================================================
--- crt/string/scanf.c	(revision 47065)
+++ crt/string/scanf.c	(working copy)
@@ -25,7 +25,14 @@
 
 #include <precomp.h>
 #include <ctype.h>
+#include <locale.h>
 
+#ifdef _LIBCNT_
+_locale_t get_locale(void){ return NULL; }
+#else
+_locale_t get_locale(void); //defined in locale.c
+#endif 
+
 // HACK for LIBCNT
 #ifndef debugstr_a
 #define debugstr_a
@@ -56,39 +63,74 @@
 }
 
 #ifndef _LIBCNT_
-/* vfscanf */
+/* vfscanf_l */
 #undef WIDE_SCANF
 #undef CONSOLE
 #undef STRING
+#undef SECURE
 #include "scanf.h"
 
-/* vfwscanf */
+/* vfscanf_l */
+#define SECURE 1
+#include "scanf.h"
+
+/* vfwscanf_l */
 #define WIDE_SCANF 1
 #undef CONSOLE
 #undef STRING
+#undef SECURE
 #include "scanf.h"
+
+/* vfwscanf_s_l */
+#define SECURE 1
+#include "scanf.h"
 #endif
 
-/* vsscanf */
+/* vsscanf_l */
 #undef WIDE_SCANF
 #undef CONSOLE
 #define STRING 1
+#undef SECURE
 #include "scanf.h"
 
-/* vswscanf */
+/* vsscanf_s_l */
+#define SECURE 1
+#include "scanf.h"
+
+/* vswscanf_l */
 #define WIDE_SCANF 1
 #undef CONSOLE
 #define STRING 1
+#undef SECURE
 #include "scanf.h"
 
+/* vswscanf_s_l */
+#define SECURE 1
+#include "scanf.h"
+
 #ifndef _LIBCNT_
-/* vcscanf */
+/* vcscanf_l */
 #undef WIDE_SCANF
 #define CONSOLE 1
 #undef STRING
+#undef SECURE
 #include "scanf.h"
 
+/* vcscanf_s_l */
+#define SECURE 1
+#include "scanf.h"
 
+/* vcwscanf_l */
+#define WIDE_SCANF 1
+#define CONSOLE 1
+#undef STRING
+#undef SECURE
+#include "scanf.h"
+
+/* vcwscanf_s_l */
+#define SECURE 1
+#include "scanf.h"
+
 /*********************************************************************
  *		fscanf (MSVCRT.@)
  */
@@ -98,26 +140,112 @@
     int res;
 
     va_start(valist, format);
-    res = vfscanf(file, format, valist);
+    res = vfscanf_l(file, format, NULL, valist);
     va_end(valist);
     return res;
 }
 
 /*********************************************************************
+ *		_fscanf_l (MSVCRT.@)
+ */
+int CDECL _fscanf_l(FILE *file, const char *format,
+        _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vfscanf_l(file, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		fscanf_s (MSVCRT.@)
+ */
+int CDECL fscanf_s(FILE *file, const char *format, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, format);
+    res = vfscanf_s_l(file, format, NULL, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_fscanf_s_l (MSVCRT.@)
+ */
+int CDECL _fscanf_s_l(FILE *file, const char *format,
+        _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vfscanf_s_l(file, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
  *		scanf (MSVCRT.@)
  */
-int scanf(const char *format, ...)
+int CDECL scanf(const char *format, ...)
 {
     va_list valist;
     int res;
 
     va_start(valist, format);
-    res = vfscanf(stdin, format, valist);
+    res = vfscanf_l(stdin, format, NULL, valist);
     va_end(valist);
     return res;
 }
 
 /*********************************************************************
+ *		_scanf_l (MSVCRT.@)
+ */
+int CDECL _scanf_l(const char *format, _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vfscanf_l(stdin, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		scanf_s (MSVCRT.@)
+ */
+int CDECL scanf_s(const char *format, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, format);
+    res = vfscanf_s_l(stdin, format, NULL, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_scanf_s_l (MSVCRT.@)
+ */
+int CDECL _scanf_s_l(const char *format, _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vfscanf_s_l(stdin, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
  *		fwscanf (MSVCRT.@)
  */
 int fwscanf(FILE *file, const wchar_t *format, ...)
@@ -126,44 +254,174 @@
     int res;
 
     va_start(valist, format);
-    res = vfwscanf(file, format, valist);
+    res = vfwscanf_l(file, format, NULL, valist);
     va_end(valist);
     return res;
 }
 
+/*********************************************************************
+ *		_fwscanf_l (MSVCRT.@)
+ */
+int CDECL _fwscanf_l(FILE *file, const wchar_t *format,
+        _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
 
+    va_start(valist, locale);
+    res = vfwscanf_l(file, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
 /*********************************************************************
+ *		fwscanf_s (MSVCRT.@)
+ */
+int CDECL fwscanf_s(FILE *file, const wchar_t *format, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, format);
+    res = vfwscanf_s_l(file, format, NULL, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_fwscanf_s_l (MSVCRT.@)
+ */
+int CDECL _fwscanf_s_l(FILE *file, const wchar_t *format,
+        _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vfwscanf_s_l(file, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
+
+/*********************************************************************
  *		wscanf (MSVCRT.@)
  */
-int wscanf(const wchar_t *format, ...)
+int CDECL wscanf(const wchar_t *format, ...)
 {
     va_list valist;
     int res;
 
     va_start(valist, format);
-    res = vfwscanf(stdin, format, valist);
+    res = vfwscanf_l(stdin, format, NULL, valist);
     va_end(valist);
     return res;
 }
-#endif
 
+/*********************************************************************
+ *		_wscanf_l (MSVCRT.@)
+ */
+int CDECL _wscanf_l(const wchar_t *format,
+        _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
 
+    va_start(valist, locale);
+    res = vfwscanf_l(stdin, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
 /*********************************************************************
+ *		wscanf_s (MSVCRT.@)
+ */
+int CDECL wscanf_s(const wchar_t *format, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, format);
+    res = vfwscanf_s_l(stdin, format, NULL, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_wscanf_s_l (MSVCRT.@)
+ */
+int CDECL _wscanf_s_l(const wchar_t *format,
+        _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vfwscanf_s_l(stdin, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+#endif
+
+/*********************************************************************
  *		sscanf (MSVCRT.@)
  */
-int sscanf(const char *str, const char *format, ...)
+int CDECL sscanf(const char *str, const char *format, ...)
 {
     va_list valist;
     int res;
 
     va_start(valist, format);
-    res = vsscanf(str, format, valist);
+    res = vsscanf_l(str, format, NULL, valist);
     va_end(valist);
     return res;
 }
 
+/*********************************************************************
+ *		_sscanf_l (MSVCRT.@)
+ */
+int CDECL _sscanf_l(const char *str, const char *format,
+        _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
 
+    va_start(valist, locale);
+    res = vsscanf_l(str, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
 /*********************************************************************
+ *		sscanf_s (MSVCRT.@)
+ */
+int CDECL sscanf_s(const char *str, const char *format, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, format);
+    res = vsscanf_s_l(str, format, NULL, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_sscanf_s_l (MSVCRT.@)
+ */
+int CDECL _sscanf_s_l(const char *str, const char *format,
+        _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vsscanf_s_l(str, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
  *		swscanf (MSVCRT.@)
  */
 int CDECL swscanf(const wchar_t *str, const wchar_t *format, ...)
@@ -172,11 +430,55 @@
     int res;
 
     va_start(valist, format);
-    res = vswscanf(str, format, valist);
+    res = vswscanf_l(str, format, NULL, valist);
     va_end(valist);
     return res;
 }
 
+/*********************************************************************
+ *		_swscanf_l (MSVCRT.@)
+ */
+int CDECL _swscanf_l(const wchar_t *str, const wchar_t *format,
+        _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vswscanf_l(str, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		swscanf_s (MSVCRT.@)
+ */
+int CDECL swscanf_s(const wchar_t *str, const wchar_t *format, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, format);
+    res = vswscanf_s_l(str, format, NULL, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_swscanf_s_l (MSVCRT.@)
+ */
+int CDECL _swscanf_s_l(const wchar_t *str, const wchar_t *format,
+        _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vswscanf_s_l(str, format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
 #ifndef _LIBCNT_
 /*********************************************************************
  *		_cscanf (MSVCRT.@)
@@ -187,8 +489,106 @@
     int res;
 
     va_start(valist, format);
-    res = vcscanf(format, valist);
+    res = vcscanf_l(format, NULL, valist);
     va_end(valist);
     return res;
 }
+
+/*********************************************************************
+ *		_cscanf_l (MSVCRT.@)
+ */
+int CDECL _cscanf_l(const char *format, _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vcscanf_l(format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_cscanf_s (MSVCRT.@)
+ */
+int CDECL _cscanf_s(const char *format, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, format);
+    res = vcscanf_s_l(format, NULL, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_cscanf_s_l (MSVCRT.@)
+ */
+int CDECL _cscanf_s_l(const char *format, _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vcscanf_s_l(format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_cwscanf (MSVCRT.@)
+ */
+int CDECL _cwscanf(const wchar_t *format, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, format);
+    res = vcwscanf_l(format, NULL, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_cwscanf_l (MSVCRT.@)
+ */
+int CDECL _cwscanf_l(const wchar_t *format, _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vcwscanf_l(format, locale, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_cwscanf_s (MSVCRT.@)
+ */
+int CDECL _cwscanf_s(const wchar_t *format, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, format);
+    res = vcwscanf_s_l(format, NULL, valist);
+    va_end(valist);
+    return res;
+}
+
+/*********************************************************************
+ *		_cwscanf_s_l (MSVCRT.@)
+ */
+int CDECL _cwscanf_s_l(const wchar_t *format, _locale_t locale, ...)
+{
+    va_list valist;
+    int res;
+
+    va_start(valist, locale);
+    res = vcwscanf_s_l(format, locale, valist);
+    va_end(valist);
+    return res;
+}
 #endif
Index: crt/string/scanf.h
===================================================================
--- crt/string/scanf.h	(revision 47065)
+++ crt/string/scanf.h	(working copy)
@@ -48,7 +48,19 @@
 #ifdef CONSOLE
 #define _GETC_(file) (consumed++, _getch())
 #define _UNGETC_(nch, file) do { _ungetch(nch); consumed--; } while(0)
-#define _FUNCTION_ int vcscanf(const char *format, va_list ap)
+#ifdef WIDE_SCANF
+#ifdef SECURE
+#define _FUNCTION_ static int vcwscanf_s_l(const wchar_t *format, _locale_t locale, va_list ap)
+#else  /* SECURE */
+#define _FUNCTION_ static int vcwscanf_l(const wchar_t *format, _locale_t locale, va_list ap)
+#endif /* SECURE */
+#else  /* WIDE_SCANF */
+#ifdef SECURE
+#define _FUNCTION_ static int vcscanf_s_l(const char *format, _locale_t locale, va_list ap)
+#else  /* SECURE */
+#define _FUNCTION_ static int vcscanf_l(const char *format, _locale_t locale, va_list ap)
+#endif /* SECURE */
+#endif /* WIDE_SCANF */
 #else
 #ifdef STRING
 #undef _EOF_
@@ -56,19 +68,35 @@
 #define _GETC_(file) (consumed++, *file++)
 #define _UNGETC_(nch, file) do { file--; consumed--; } while(0)
 #ifdef WIDE_SCANF
-#define _FUNCTION_ int vswscanf(const wchar_t *file, const wchar_t *format, va_list ap)
+#ifdef SECURE
+#define _FUNCTION_ static int vswscanf_s_l(const wchar_t *file, const wchar_t *format, _locale_t locale, va_list ap)
+#else  /* SECURE */
+#define _FUNCTION_ static int vswscanf_l(const wchar_t *file, const wchar_t *format, _locale_t locale, va_list ap)
+#endif /* SECURE */
 #else /* WIDE_SCANF */
-#define _FUNCTION_ int vsscanf(const char *file, const char *format, va_list ap)
+#ifdef SECURE
+#define _FUNCTION_ static int vsscanf_s_l(const char *file, const char *format, _locale_t locale, va_list ap)
+#else  /* SECURE */
+#define _FUNCTION_ static int vsscanf_l(const char *file, const char *format, _locale_t locale, va_list ap)
+#endif /* SECURE */
 #endif /* WIDE_SCANF */
 #else /* STRING */
 #ifdef WIDE_SCANF
 #define _GETC_(file) (consumed++, fgetwc(file))
 #define _UNGETC_(nch, file) do { ungetwc(nch, file); consumed--; } while(0)
-#define _FUNCTION_ int vfwscanf(FILE* file, const wchar_t *format, va_list ap)
+#ifdef SECURE
+#define _FUNCTION_ static int vfwscanf_s_l(FILE* file, const wchar_t *format, _locale_t locale, va_list ap)
+#else  /* SECURE */
+#define _FUNCTION_ static int vfwscanf_l(FILE* file, const wchar_t *format, _locale_t locale, va_list ap)
+#endif /* SECURE */
 #else /* WIDE_SCANF */
 #define _GETC_(file) (consumed++, fgetc(file))
 #define _UNGETC_(nch, file) do { ungetc(nch, file); consumed--; } while(0)
-#define _FUNCTION_ int vfscanf(FILE* file, const char *format, va_list ap)
+#ifdef SECURE
+#define _FUNCTION_ static int vfscanf_s_l(FILE* file, const char *format, _locale_t locale, va_list ap)
+#else  /* SECURE */
+#define _FUNCTION_ static int vfscanf_l(FILE* file, const char *format, _locale_t locale, va_list ap)
+#endif /* SECURE */
 #endif /* WIDE_SCANF */
 #endif /* STRING */
 #endif /* CONSOLE */
@@ -82,7 +110,7 @@
     TRACE("(%s):\n", debugstr_a(format));
 #else /* CONSOLE */
 #ifdef STRING
-    TRACE("%s (%s)\n", file, debugstr_a(format));
+    TRACE("%s (%s)\n", debugstr_a(file), debugstr_a(format));
 #else /* STRING */
     TRACE("%p (%s)\n", file, debugstr_a(format));
 #endif /* STRING */
@@ -91,6 +119,9 @@
     nch = _GETC_(file);
     if (nch == _EOF_) return _EOF_RET;
 
+    if(!locale)
+        locale = get_locale();
+
     while (*format) {
 	/* a whitespace character in the format string causes scanf to read,
 	 * but not store, all consecutive white-space characters in the input
@@ -250,7 +281,7 @@
                         nch = _GETC_(file);
                     }
 		    /* get first digit. */
-		    if ('.' != nch) {
+		    if (*locale->locinfo->lconv->decimal_point != nch) {
 		      if (!_ISDIGIT_(nch)) break;
 		      cur = (nch - '0');
 		      nch = _GETC_(file);
@@ -262,10 +293,10 @@
 			if (width>0) width--;
 		      }
 		    } else {
-		      cur = 0; /* MaxPayneDemo Fix: .8 -> 0.8 */
+		      cur = 0; /* Fix: .8 -> 0.8 */
 		    }
 		    /* handle decimals */
-                    if (width!=0 && nch == '.') {
+                    if (width!=0 && nch == *locale->locinfo->lconv->decimal_point) {
                         long double dec = 1;
                         nch = _GETC_(file);
 			if (width>0) width--;
@@ -336,12 +367,25 @@
 #endif /* WIDE_SCANF */
 	    charstring: { /* read a word into a char */
 		    char *sptr = suppress ? NULL : va_arg(ap, char*);
+                    char *sptr_beg = sptr;
+#ifdef SECURE
+                    unsigned size = suppress ? UINT_MAX : va_arg(ap, unsigned);
+#else
+                    unsigned size = UINT_MAX;
+#endif
                     /* skip initial whitespace */
                     while ((nch!=_EOF_) && _ISSPACE_(nch))
                         nch = _GETC_(file);
                     /* read until whitespace */
                     while (width!=0 && (nch!=_EOF_) && !_ISSPACE_(nch)) {
-                        if (!suppress) *sptr++ = _CHAR2SUPPORTED_(nch);
+                        if (!suppress) {
+                            *sptr++ = _CHAR2SUPPORTED_(nch);
+                            if(size>1) size--;
+                            else {
+                                *sptr_beg = 0;
+                                return rd;
+                            }
+                        }
 			st++;
                         nch = _GETC_(file);
 			if (width>0) width--;
@@ -352,12 +396,25 @@
                 break;
 	    widecharstring: { /* read a word into a wchar_t* */
 		    wchar_t *sptr = suppress ? NULL : va_arg(ap, wchar_t*);
+                    wchar_t *sptr_beg = sptr;
+#ifdef SECURE
+                    unsigned size = suppress ? UINT_MAX : va_arg(ap, unsigned);
+#else
+                    unsigned size = UINT_MAX;
+#endif
                     /* skip initial whitespace */
                     while ((nch!=_EOF_) && _ISSPACE_(nch))
                         nch = _GETC_(file);
                     /* read until whitespace */
                     while (width!=0 && (nch!=_EOF_) && !_ISSPACE_(nch)) {
-                        if (!suppress) *sptr++ = _WIDE2SUPPORTED_(nch);
+                        if (!suppress) {
+                            *sptr++ = _WIDE2SUPPORTED_(nch);
+                            if(size>1) size--;
+                            else {
+                                *sptr_beg = 0;
+                                return rd;
+                            }
+                        }
 			st++;
                         nch = _GETC_(file);
 			if (width>0) width--;
@@ -386,10 +443,23 @@
 #endif /* WIDE_SCANF */
 	  character: { /* read single character into char */
                     char *str = suppress ? NULL : va_arg(ap, char*);
+                    char *pstr = str;
+#ifdef SECURE
+                    unsigned size = suppress ? UINT_MAX : va_arg(ap, unsigned)/sizeof(char);
+#else
+                    unsigned size = UINT_MAX;
+#endif
                     if (width == -1) width = 1;
-                    while ((width != 0) && (nch != _EOF_))
+                    while (width && (nch != _EOF_))
                     {
-                        if (!suppress) *str++ = _CHAR2SUPPORTED_(nch);
+                        if (!suppress) {
+                            *str++ = _CHAR2SUPPORTED_(nch);
+                            if(size) size--;
+                            else {
+                                *pstr = 0;
+                                return rd;
+                            }
+                        }
                         st++;
                         width--;
                         nch = _GETC_(file);
@@ -398,10 +468,23 @@
 		break;
 	  widecharacter: { /* read single character into a wchar_t */
                     wchar_t *str = suppress ? NULL : va_arg(ap, wchar_t*);
+                    wchar_t *pstr = str;
+#ifdef SECURE
+                    unsigned size = suppress ? UINT_MAX : va_arg(ap, unsigned)/sizeof(wchar_t);
+#else
+                    unsigned size = UINT_MAX;
+#endif
                     if (width == -1) width = 1;
-                    while ((width != 0) && (nch != _EOF_))
+                    while (width && (nch != _EOF_))
                     {
-                        if (!suppress) *str++ = _WIDE2SUPPORTED_(nch);
+                        if (!suppress) {
+                            *str++ = _WIDE2SUPPORTED_(nch);
+                            if(size) size--;
+                            else {
+                                *pstr = 0;
+                                return rd;
+                            }
+                        }
                         st++;
                         width--;
                         nch = _GETC_(file);
@@ -434,14 +517,19 @@
 		    RTL_BITMAP bitMask;
                     ULONG *Mask;
 		    int invert = 0; /* Set if we are NOT to find the chars */
+#ifdef SECURE
+                    unsigned size = suppress ? UINT_MAX : va_arg(ap, unsigned)/sizeof(_CHAR_);
+#else
+                    unsigned size = UINT_MAX;
+#endif
 
-            /* Init our bitmap */
+		    /* Init our bitmap */
 #ifdef _LIBCNT_
-            Mask = RtlAllocateHeap(RtlGetProcessHeap(), HEAP_ZERO_MEMORY, _BITMAPSIZE_/8);
+		    Mask = RtlAllocateHeap(RtlGetProcessHeap(), HEAP_ZERO_MEMORY, _BITMAPSIZE_/8);
 #else
-            Mask = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, _BITMAPSIZE_/8);
+		    Mask = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, _BITMAPSIZE_/8);
 #endif
-            RtlInitializeBitMap(&bitMask, Mask, _BITMAPSIZE_);
+		    RtlInitializeBitMap(&bitMask, Mask, _BITMAPSIZE_);
 
 		    /* Read the format */
 		    format++;
@@ -482,6 +570,11 @@
                         st++;
                         nch = _GETC_(file);
                         if (width>0) width--;
+                        if(size>1) size--;
+                        else {
+                            *str = 0;
+                            return rd;
+                        }
                     }
                     /* terminate */
                     if (!suppress) *sptr = 0;
Index: crt/string/strcoll.c
===================================================================
--- crt/string/strcoll.c	(revision 47065)
+++ crt/string/strcoll.c	(working copy)
@@ -14,7 +14,7 @@
    greater than zero if the collated form of S1 is lexicographically
    less than, equal to or greater than the collated form of S2.  */
 
-#if 1
+
 /*
  * @unimplemented
  */
@@ -24,22 +24,12 @@
 }
 
 /*
- * @unimplemented
+ * @implemented
  */
 int _stricoll(const char* s1, const char* s2)
 {
-    return _stricmp(s1, s2);
+  /* FIXME: handle collates */
+  TRACE("str1 %s str2 %s\n", debugstr_a(s1), debugstr_a(s2));
+  return lstrcmpiA( s1, s2 );
 }
 
-#else
-int strcoll (const char* s1,const char* s2)
-{
-    int ret;
-    ret = CompareStringA(LOCALE_USER_DEFAULT,0,s1,strlen(s1),s2,strlen(s2));
-    if (ret == 0)
-        return 0;
-    else
-        return ret - 2;
-    return 0;
-}
-#endif
Index: crt/string/strdup.c
===================================================================
--- crt/string/strdup.c	(revision 47065)
+++ crt/string/strdup.c	(working copy)
@@ -4,14 +4,14 @@
 /*
  * @implemented
  */
-char *_strdup(const char *_s)
+char *_strdup(const char *str)
 {
-  char *rv;
-  if (_s == 0)
-    return 0;
-  rv = (char *)malloc(strlen(_s) + 1);
-  if (rv == 0)
-    return 0;
-  strcpy(rv, _s);
-  return rv;
+    if(str)
+    {
+      char * ret = malloc(strlen(str)+1);
+      if (ret) strcpy( ret, str );
+      return ret;
+    }
+    else return 0;
 }
+
Index: crt/string/strrev.c
===================================================================
--- crt/string/strrev.c	(revision 47065)
+++ crt/string/strrev.c	(working copy)
@@ -13,20 +13,18 @@
 /*
  * @implemented
  */
-char * _strrev(char *s)
+char* CDECL _strrev(char *str)
 {
-	char a, *b, *e;
-	b=e=s;
-	while (*e)
-		e++;
-	e--; /* start at last char, not NULL char */
-	while ( b < e )
-	{
-		a=*b;
-		*b=*e;
-		*e=a;
-		b++;
-		e--;
-	}
-	return s; /* return ptr to beginning of string */
+  char * p1;
+  char * p2;
+
+  if (str && *str)
+    for (p1 = str, p2 = str + strlen(str) - 1; p2 > p1; ++p1, --p2)
+    {
+      *p1 ^= *p2;
+      *p2 ^= *p1;
+      *p1 ^= *p2;
+    }
+
+  return str;
 }
Index: crt/string/strset.c
===================================================================
--- crt/string/strset.c	(revision 47065)
+++ crt/string/strset.c	(working copy)
@@ -8,44 +8,27 @@
  *              25/11/05: Added license header
  */
 
-#if defined(__GNUC__)
-#define __int64 long long
-#endif
+#include <precomp.h>
 
-#ifdef _WIN64
-typedef unsigned __int64 size_t;
-#else
-typedef unsigned int size_t;
-#endif
-
 /*
  * @implemented
  */
-char* _strnset(char* szToFill, int szFill, size_t sizeMaxFill)
+char* CDECL _strnset(char* str, int value, size_t len)
 {
-	char *t = szToFill;
-	int i = 0;
-	while (*szToFill != 0 && i < (int) sizeMaxFill)
-	{
-		*szToFill = szFill;
-		szToFill++;
-		i++;
-
-	}
-	return t;
+  if (len > 0 && str)
+    while (*str && len--)
+      *str++ = value;
+  return str;
 }
 
 /*
  * @implemented
  */
-char* _strset(char* szToFill, int szFill)
+char* CDECL _strset(char* str, int value)
 {
-	char *t = szToFill;
-	while (*szToFill != 0)
-	{
-		*szToFill = szFill;
-		szToFill++;
+  char *ptr = str;
+  while (*ptr)
+    *ptr++ = value;
 
-	}
-	return t;
+  return str;
 }
Index: crt/string/strtod.c
===================================================================
--- crt/string/strtod.c	(revision 47065)
+++ crt/string/strtod.c	(working copy)
@@ -1,103 +1,118 @@
-/* Copyright (C) 1996 DJ Delorie, see COPYING.DJ for details */
-/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
 
 #include <precomp.h>
+#include <locale.h>
+#include <internal/wine/msvcrt.h>
 
-/*
- * @implemented
+/*********************************************************************
+ *		_strtod_l  (MSVCRT.@)
  */
-double
-strtod(const char *s, char **sret)
+double CDECL _strtod_l( const char *str, char **end, _locale_t locale)
 {
-  long double r;		/* result */
-  int e;			/* exponent */
-  long double d;		/* scale */
-  int sign;			/* +- 1.0 */
-  int esign;
-  int i;
-  int flags=0;
+    unsigned __int64 d=0, hlp;
+    int exp=0, sign=1;
+    const char *p;
+    double ret;
 
-  r = 0.0;
-  sign = 1;
-  e = 0;
-  esign = 1;
+    if(!str) {
+        _invalid_parameter(NULL, NULL, NULL, 0, 0);
+        *_errno() = EINVAL;
+        return 0;
+    }
 
-  if (s == NULL)
-     return r;
+    if(!locale)
+        locale = get_locale();
 
+    /* FIXME: use *_l functions */
+    p = str;
+    while(isspace(*p))
+        p++;
 
-  while ((*s == ' ') || (*s == '\t'))
-    s++;
+    if(*p == '-') {
+        sign = -1;
+        p++;
+    } else  if(*p == '+')
+        p++;
 
-  if (*s == '+')
-    s++;
-  else if (*s == '-')
-  {
-    sign = -1;
-    s++;
-  }
+    while(isdigit(*p)) {
+        hlp = d*10+*(p++)-'0';
+        if(d>UINT64_MAX/10 || hlp<d) {
+            exp++;
+            break;
+        } else
+            d = hlp;
+    }
+    while(isdigit(*p)) {
+        exp++;
+        p++;
+    }
 
-  while ((*s >= '0') && (*s <= '9'))
-  {
-    flags |= 1;
-    r *= 10.0;
-    r += *s - '0';
-    s++;
-  }
+    if(*p == *locale->locinfo->lconv->decimal_point)
+        p++;
 
-  if (*s == '.')
-  {
-    d = 0.1L;
-    s++;
-    while ((*s >= '0') && (*s <= '9'))
-    {
-      flags |= 2;
-      r += d * (*s - '0');
-      s++;
-      d *= 0.1L;
+    while(isdigit(*p)) {
+        hlp = d*10+*(p++)-'0';
+        if(d>UINT64_MAX/10 || hlp<d)
+            break;
+
+        d = hlp;
+        exp--;
     }
-  }
+    while(isdigit(*p))
+        p++;
 
-  if (flags == 0)
-  {
-    if (sret)
-      *sret = (char *)s;
-    return 0;
-  }
-
-  if ((*s == 'e') || (*s == 'E'))
-  {
-    s++;
-    if (*s == '+')
-      s++;
-    else if (*s == '-')
-    {
-      s++;
-      esign = -1;
+    if(p == str) {
+        if(end)
+            *end = (char*)str;
+        return 0.0;
     }
-    if ((*s < '0') || (*s > '9'))
-    {
-      if (sret)
-	*sret = (char *)s;
-      return r;
-    }
 
-    while ((*s >= '0') && (*s <= '9'))
-    {
-      e *= 10;
-      e += *s - '0';
-      s++;
+    if(*p=='e' || *p=='E' || *p=='d' || *p=='D') {
+        int e=0, s=1;
+
+        p++;
+        if(*p == '-') {
+            s = -1;
+            p++;
+        } else if(*p == '+')
+            p++;
+
+        if(isdigit(*p)) {
+            while(isdigit(*p)) {
+                if(e>INT_MAX/10 || (e=e*10+*p-'0')<0)
+                    e = INT_MAX;
+                p++;
+            }
+            e *= s;
+
+            if(exp<0 && e<0 && exp+e>=0) exp = INT_MIN;
+            else if(exp>0 && e>0 && exp+e<0) exp = INT_MAX;
+            else exp += e;
+        } else {
+            if(*p=='-' || *p=='+')
+                p--;
+            p--;
+        }
     }
-  }
 
-  if (esign < 0)
-    for (i = 1; i <= e; i++)
-      r *= 0.1L;
-  else
-    for (i = 1; i <= e; i++)
-      r *= 10.0;
+    if(exp>0)
+        ret = (double)sign*d*pow(10, exp);
+    else
+        ret = (double)sign*d/pow(10, -exp);
 
-  if (sret)
-    *sret = (char *)s;
-  return r * sign;
+    if((d && ret==0.0) || isinf(ret))
+        *_errno() = ERANGE;
+
+    if(end)
+        *end = (char*)p;
+
+    return ret;
 }
+
+/*
+ * @implemented
+ */
+double
+strtod(const char *str, char **end)
+{
+    return _strtod_l( str, end, NULL );
+}
